-- The prime factors of 13195 are 5, 7, 13 and 29.  --
-- What is the largest prime factor of the number 600851475143?

module P003 (p003) where

import Data.List (uncons)
import Data.Maybe (fromJust)
import ProjectEuler (isPrime)

maxPrimeFactor :: Int -> Int
maxPrimeFactor n
  | isPrime n = n
  | even n = maxPrimeFactor $ n `div` 2
  | otherwise = maxPrimeFactor $ n `div` (fst . fromJust $ uncons [i | i <- [3, 5 ..], n `mod` i == 0 && isPrime i])

p003 :: IO ()
p003 = do
  let result = maxPrimeFactor 600851475143
  putStrLn $
    "Project Euler, Problem 3\n"
      ++ "Answer: "
      ++ show result
