-- Let d(n) be defined as the sum of proper divisors of n (numbers less than n which divide evenly into n).
-- If d(a) = b and d(b) = a, where a ≠ b, then a and b are an amicable pair and each of a and b are called amicable numbers.
--
-- For example, the proper divisors of 220 are 1, 2, 4, 5, 10, 11, 20, 22, 44, 55 and 110; therefore d(220) = 284.
-- The proper divisors of 284 are 1, 2, 4, 71 and 142; so d(284) = 220.
--
-- Evaluate the sum of all the amicable numbers under 10000.

module P021 (p021) where

import ProjectEuler (sumProperDivisors)

amicable :: Int -> Int -> Bool
amicable x y = x /= y && sumProperDivisors x == y && sumProperDivisors y == x

sumAmicable :: Int -> Int
sumAmicable n = sum [x | x <- [1 .. n - 1], amicable x $ sumProperDivisors x]

p021 :: IO ()
p021 = do
  let result = sumAmicable 10000
  putStrLn $
    "Project Euler, Problem 21\n"
      ++ "Answer: "
      ++ show result
